// my_namespace.cpp
#include "my_essentials.hpp"
namespace ice_cube{

	class water{
	public:
		string get_water() {
			return make_water();	
		}
	private: 
		string hydrogen() {
			return "H";
		}
		string oxygen() {
			return "O";
		}
		string make_water(void) {
			return(hydrogen()+"2"+oxygen());
		}
	};
	 /*
	Note: 
	only classes end with a semicolon (;) after 
	their closing bracket }, but functions and 
	namespaces do not require that semicolon.
	*/

	string freezer(string foodstuff) {
		return (
	"\n Hello, please have this  cube of\n\t<" 
	+ foodstuff
	+ " @ -18 degrees Celsius> in your drink.\n" 
	);

	// Here \n means new line and \t 
	// means a tab space
	}
}


int main()
{
	ice_cube::water wt;	// Declaration of a 	
	// variable wt of type class water, 
	// which is in the scope of 
	// namespace ice_cube. 
	cout << ice_cube::freezer(wt.get_water());
	// it calls the function freezer, 
	// which is in the scope of the ice_cube. 
	// It has an input parameter 
	// of get_water(), which is 
	// a member function of the class water. 
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
