// brace_initializer.cpp
// Caution: IT DOES NOT WORK IN VC++12, BUT WORKS IN GCC-v-4.7.0
#include "my_essentials.hpp"
int main()
{
	//Old style of initializing raw 	
	//array (my_arr[]) with brace of data
	double my_arr[] = {2.3, 4.5, 6.7, 8.9};

	//then copy the my_arr[] to a 	
	//container (my_vector1) by this 	
	//typical statement:
	
	vector<double>my_vector1(my_arr, my_arr
		+ sizeof(my_arr)/sizeof(my_arr[0]) );
	
	//C++11 allows direct 	
	//brace initialization for containers: 
	
	vector<double>my_vector2{2.3, 4.5, 6.7, 8.9};

	//Note: This advancement is yet to arrive in 	
	//VC++, however is available in GCC-v-4.7.0  
	//Test:
	if(my_vector1 == my_vector2)
		cout << "\n\tYes, both methods yield"
			<< " same result!\n";
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
