// my_reference_pointer.cpp

#include "my_essentials.hpp"

int main()
{
// Part 1: This is to prove that 
// the address of an object is a constant.

	int x = 0;
	cout	<< "\n Let x be 0,\tthen x = " << x 
		<< ";\tits address &x = " << &x;

	x = 7777; 
	cout 	<< "\n Let x be 7777,\tthen x = " << x 
		<< ";\tthe address &x = " << &x;

	x = 4; 
	cout 	<< "\n Let x be 4,\tthen x = " << x 
		<< ";\tthe address &x = " << &x 
		<< endl;

	cout 	<< "\n So, the value changes but "
		<< "the address remains constant.\n"
		<<"------------------------------\n";

// Part 2: Demo for creation of 
// pointers and references.

	cout 	<< "\n Let xp and xr be a pointer"
		<< " and a reference, respectively," 
		<< "\n to the x. Then it should be"
		<< " declared as:"
		<< "\n int *xp = &x, &xr = x;\n";

	int *xp = &x, &xr = x;
	cout 	<< "\n Then,\n xp = " << xp 
		<< ", *xp = " << *xp << endl;
	cout 	<< " xr = " << xr 
		<< ", &xr = " << &xr << endl;
	
	cout 	<< "\n So, the *xp and xr reflects"
		<< " the value of x. Similarly, "
		<< "\n xp and &xr reflects"
		<< " the address of x.\n"
		<<"------------------------------\n";

	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
