// properties_of_pointers.cpp

#include "my_essentials.hpp"

int main()
{
	int x =10, y = 20; 
	cout << "x = "<<x<<"; y = "<<y<<endl;
	cout<<"Address: &x = "<< &x
	<<"; &y = "<<&y<<endl;
	
	int &xr = x; 
	cout << "Value of &xr = "<<&xr;
	cout << "; xr = "<<xr<<endl;
	// then xr cannot be assigned to y;
	
	int *xp = &x;
	cout << "Value of pointer xp = "<<xp;
	cout << "; *xp = "<<*xp<<endl;
	xp = &y; //this works.
	cout << "Value of pointer xp = "<<xp;
	cout << "; *xp = "<<*xp<<endl;

	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
