#include "my_essentials.hpp"
#include "2o_implemenation.h"

class my_pimpl{
public:
	void use_pimpl() {
		hello();
	}
private:
	shared_ptr <my_implementation> pimpl_; /* Note: we have started using smart pointer! */
	
	void hello() {
		
		pimpl_->cout_it();	
		cout << "\n This pimpl_ is of size = "
		<< sizeof(pimpl_) <<" bytes," 
		<< "\n whereas sizeof(my_implementation) = "
		<< sizeof(my_implementation) << " bytes." 
		<< "\n Thus, without consuming huge memory for" 
		<<" using the implementation,\n we have used it"
		<<" by the pimpl_ !" << endl;
	}
};

int main()
{
	my_pimpl test;
	test.use_pimpl();
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
