// inheritance.cpp

// Illustration of the inheritance of a 
// Derived class from a Base class. 

#include "my_essentials.hpp"

class Base{
public:
	void base_function() {
		cout<<"\t* operating at base class\n";
	}
};

class Derived: public Base {
public:
	void derived_function() {
		cout<<"\t* operating at derived class\n";
		base_function();
	}
};

int main()
{
 Derived derived;
 cout
 << "\ncalling: \"derived.base_function();\"\n";
 derived.base_function();
 cout
 << "\ncalling: \"derived.derived_function();\"\n";
 derived.derived_function();
 just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
