// calling_order.cpp

#include "my_essentials.hpp"

class my_general{
public:
	my_general(){
		cout<< "\n\t my_general constructor\n";
	}
	~my_general(){
		cout<< "\n\t my_general  destructor\n";
	}
};

class my_special{
public:
	my_special(){
		cout<< "\n\t my_special constructor\n";
	}
	~my_special(){
		cout<< "\n\t my_special  destructor\n";
	}
};

class my_base{
public:
	my_base(){
		cout<< "\n\t my_base constructor\n";
	}
	~my_base(){
		cout<< "\n\t my_base  destructor\n";
		just_pause();
	}
};

class my_derived: public my_base{ // my_base class is inherited
	my_general mg; /* the declared object mg is of type my_general, 
				   in otherwords it is composition of my_general*/
public:
	my_derived(){
		cout<< "\n\t my_derived constructor\n";
	}
	void my_function(int x)
	{
		my_special ms;
		cout<< "\n\t my_function(int "<< x <<")\n";
	}
	~my_derived(){
		cout<< "\n\t my_derived  destructor\n";
	}
};

int main()
{
	my_derived md;
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
