//investor_virtual_function.cpp

#include "../../my_essentials.hpp"

#include "4l_investor_virtual_function.h"

struct market_scenario{
	bool scenario(){
		// Market is in pickup, so
		return true;
		//return false;
	}
};

/* where, struct is called a structure 
   and it is a type of class, but its 
   members are public by default, whereas 
   members of class are private by default. 
   For convenience, simple data collection 
   is defined in a structure and a class is 
   for more than just a collection of data.
 */   

class advisor_staff{
public:
	std::string Name;
	std::string Register_number;
	double Investment_amount;// in USD
	double Risk_tolerance;// in %
	double Duration;// in years
	bool portfolio();
};

bool advisor_staff::portfolio()
{
/*
   Using market_scenario and 
   investors data this function 
   produces a portfolio for the investor.
*/
	
	market_scenario ms;
	if(!ms.scenario()){
		cout	<< "\n Sorry, adverse market" 			
				<< "conditions!\n"
				<< "\t Please try later.\n";
		return false;
	}
	cout	<<"\nInvestor Name:\t" <<Name;
	cout	<<"\nRegister No:\t"<<Register_number;
	cout	<<"\nAmount:\t\t" <<Investment_amount 
			<<" USD\n";
	cout	<<"Risk tolerance:\t" 
			<<Risk_tolerance<<"%\n";
	cout	<<"Duration:\t"<< Duration
			<<" years\n";
	cout<<"\nRecommended portfolio for you:\t\n";
	
	if(Investment_amount<100000){
		if(Risk_tolerance>-10)
		cout	<<"\t\"5 Bonds + 2 Gold\"\n";
		else
		cout	<<"\t\"2 Bonds + 1 Gold "
			<<"+ 10 Equity\"\n";
	}
	else{
	if(Risk_tolerance>-10)
	cout	<< "\t\"20 Bonds + 10 Gold "
		<< "+ 1 Mortgage\"\n";
	else
	cout	<< "\t\"40 Bonds + 5 Gold "
		<< "+ 1000 Equity\"\n";
	}
	cout<<endl;
	return true;
}// portfolio

//--------------------------------------------

void investor1::make_portfolio()
{ 
	advisor_staff ad;
	ad.Name = "Mr. Mark";
	ad.Register_number = "12344321";
	ad.Investment_amount = 10000;
	ad.Risk_tolerance = -15;
	ad.Duration = 2;		
	ad.portfolio();
}

//-----------------------------------

void investor2::make_portfolio()
{ 
	advisor_staff ad;
	ad.Name = "Mr. Tom";
	ad.Register_number = "33311122";
	ad.Investment_amount = 151000;
	ad.Risk_tolerance = -5;
	ad.Duration = 3;		
	ad.portfolio();
}

//---------------------------------

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
