// regex_basic.cpp

// Caution: the following code works only in VS2012, 
// not with G++ 4.7 and VS2010.

#include <regex>
#include "my_essentials.hpp"

void regex_demo()
{
	string names("James Adam Mary Mike");
	regex space(" ");
	auto modi_names 
		= "Hello " 
		+ regex_replace(names, space, ", $") 
		// it replaces the space by 
		// a comma and a space
		+ "!"; 
	cout	<< "\n Before modification:\n " 
		<< names << endl
		<< "\n After modification:\n " 
		<< modi_names << endl;
}

int main()
{
	regex_demo();
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
