// without_RAII.cpp

#include "my_essentials.hpp"

class divbyzero{
public:
	divbyzero(double x, double y)
		: numerator(x), denominator(y){}
	double numerator, denominator;
};

// .......................................

class resource_manage{
	//double *data;
	string name;
public:
	resource_manage(string object_name, int size, double nume, double deno)
		: name(object_name) {
		//data = new double(size);
		vector<double>data(size);

		cout
		<< "\nOperating with " << name << endl
		<< "Given, numerator/denominator are "
		<< nume << '/' << deno << endl;
		if(!deno) throw(divbyzero(nume,deno));	
		cout << "Divison = " << nume/deno << endl;
	}

	//~resource_manage(){
	//	delete [] data;
	//	cout 	<< "Destructor deletes "
	//			<< name << endl;
	//}

};

// .......................................

int main()
try{
	resource_manage("my_first_pointer",10,1,0);	
	just_pause(); return 0;
}

catch(divbyzero& dz){
	cout<<"task is incomplete, because,"
		<<"\n\"Exception: Division by "
		<<dz.denominator<<"!\"\n";

	cout<<"\nSo, I skipped this task\n"
		<<"and am going to try a new task\n"; 

	resource_manage("my_second_pointer",10,1,1);
	just_pause(); return 1;
}

catch (exception& e) {
    cerr 	<< "exception caught: " 
		<< e.what() << endl;
	just_pause(); return 2;
}

catch(...){
	cout<<"\n Problem: there is an unknown exception!\n";
	just_pause(); return 3;
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
