//text_file.cpp

#include "my_essentials.hpp"
#include <iomanip>

void write_txt(string& filename)
{		
	sure_write(filename);
	fstream fo(filename, ios_base::out);
	char message[] = "\n Format of this file is integers in a 4 x 5-matrix form:\n";
	short message_size = sizeof(message);

	fo << message_size;
	fo << message;

	short data_buffer;
	short alignment =1;
	for(short i = 1; i != 20; ++i)
	{
		data_buffer = i*i;

		fo << setw(6)<< data_buffer;
		// setw(n) provides n characters of
		// width to the next field and
		// it is a member of <iomanip>.

		if(alignment%4==0) fo << endl;
		++alignment;
	}
	fo.close();
	cout << "\nThe file "<< filename 
		<< " is successfully written.\n";
}
	
int read_txt(string filename)
{
	cout << "\n Now reading the file "
			<< filename << ":\n";
	fstream fi(filename, ios_base::in);
	if(!fi){
		cout 	<< "\n Error in opening the"
			<< " file: "<< filename << endl;
		return 1;
	}

	short message_size;
	fi >> message_size;
	char message;
	for(int i =0; i != message_size; ++i)
	{
		fi.get(message);// the member function 
		// get() reads a character from file 
		// 'fi' and assigns it to the
		// character variable 'message'
		cout << message;
	}	
	short data_buffer;
	short alignment =1;
	cout << endl;
	while(fi >> data_buffer)
	{
		cout << setw(6) << data_buffer;
		if(alignment%4==0) cout << endl;
		++alignment;
	}
	cout << endl;
	fi.close();
	return 0;
}

int main()
{
	string filename("my_data1.txt");
	write_txt(filename);
	read_txt(filename);
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
