// hello_my_thread.cpp
#include <thread>
#include "my_essentials_and_concurrency.hpp"

void my_funct(){
 cout << "\n Hello, Welcome to the world of Concurrency!\n";

 auto no_of_hardware_threads 
	 = thread::hardware_concurrency();

 if(no_of_hardware_threads)
	 cout << "\n Hooray!" 
	 << " You have the multicore system\n"
	 << " and you can easily use "
	 << no_of_hardware_threads 
	 << " threads!!\n";
}

int main ()
{
    thread my_thread(my_funct);
	// the thread constructs 
	// the object my_thread and assigns with the
	// function my_funct(), therefore as soon as 
	// the construction completes, this thread 
	// begins executing the my_funct()

    my_thread.join(); /* join(), 
	# is a member function of the class thread
	# it instructs the code execution to wait at
 that statement for the completion 
	  of the task, which is carried out by the 
	  thread object my_thread; and
	# at the end of the task of my_thread it 
	  frees up resources that are specifically 
	  used by the thread my_thread.
	*/
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
