// Exception_safety_test_with_thread.cpp

#include "my_essentials_and_concurrency.hpp"

void my_funct(){
	double x = -2.0;
	if(x < 0)
	throw (
	"negative input for sqrt is not allowed!\n");
	
	cout << sqrt (x) << endl;
}

int main ()
try
{
    thread my_thread(my_funct);
    my_thread.join(); 
	just_pause();
}

catch (char* e) {
    cerr << "\n Exception caught: " << e << endl;
    just_pause();
}

catch(...){
	cout	<< "\n Problem: there is an unknown " 
		<< "exception!\n";
	just_pause();
	return 2;
}
