// Exception_safety_test_with_future.cpp

#include "my_essentials_and_concurrency.hpp"

void my_funct(){
	double x = -2.0;
	if(x < 0)
	throw (
	"negative input for sqrt is not allowed!\n");

	cout << sqrt (x) << endl;
}

int main ()
try
{
    // thread my_thread(my_funct);
	future<void> my_thread(async(my_funct));

    //my_thread.join(); 
	my_thread.get();

	just_pause();
}

catch (char* e) {
    cerr << "\n Exception caught: " << e << endl;
    just_pause();
}

catch(...){
	cout	<< "\n Problem: there is an unknown " 
		<< "exception!\n";
	just_pause();
	return 2;
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
