// common_constructors_and_operators.h

#ifndef COMMON_CONSTRUCTORS_OPERATORS_H
#define COMMON_CONSTRUCTORS_OPERATORS_H

#include "my_essentials.hpp"

class my_container_demo{
public:
	void constructors_for_all_containers();
	void operators_for_all_containers();
};
//---------------------------------------------

class investment{
	string security;
	double profit_return;
	double asset_risk;
public:
	investment();
	investment(string, double, double);
	investment(double, double);
	investment(const investment& );
	investment& operator=(const investment&);
	friend ostream& 
		operator<<(ostream&, const investment& );
};
//-----------------------------------------------

struct investment_data{
	investment 
		bank1, bond1, real_estate1, share1, 		
		car, gold;
	investment_data();
};
//------------------------------------------------

#endif
//..

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
