//lambda-number-patern.cpp

#include "my_essentials.hpp"

void pattern(int x,int y,int z,int m,vector<int>& v)
{		
	int element(0);
	generate(v.begin(), v.end(),
		[&x,&y,&z,m,&element]()->int {

		element = x*(y+z);// present element
		cout << '\t' << element << endl;	

		// Then, preparing for the next element:
		z += y;// store present y+z for next z
		   ++x;// next x 
		y *= m;// next y

		return element;// to vector v
	} );
}
int main()
{	
	// It is advisable to avoid magic constants 
	// in functions and put them in main(), so, 
	vector<int>vec(6);
	int x(1),y(1),z(0),magic_number(10);
	pattern(x,y,z,magic_number,vec);
	just_pause();
} 

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
