// nullptr1.cpp
#include "my_essentials.hpp"

void my_check(int *my_ptr)
{
	if(my_ptr)
		cout << "\nThe pointer my_ptr is "
		<< my_ptr
		<<";\n so proceed with this"
		<<" work\n";
	else
		cout << "Sorry, the pointer my_ptr"
		<<" is "<< my_ptr
		<< "; \nso proceed"
		<<" with an alternate work\n";
}

int main()
{
	int *my_ptr = nullptr;
	my_check(my_ptr);
	
	int  my_data = 1;
	int *my_another_ptr = &my_data;
	
	// *my_ptr = 1; since my_ptr is a 
	// null pointer, this assignment by value
	// makes a runtime error, but
	*my_another_ptr = 2; // is fine, because it 
	// is not a null pointer. 

	my_ptr = my_another_ptr; // So, this 	
	// assignment by pointer works for 
	// the null pointer.
	
	my_check(my_ptr);

	just_pause();
	return 0;
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
