// inheritance_and_composition.cpp

// Illustration of the combination of 
// Inheritance and Composition
 
#include "my_essentials.hpp"

class Base{
public:
	void base_function() {
		cout<<"\t* operating at base class\n";
	}
};

class External_class{
public:
	void external_function(){
		cout
		<<"\t* operating at external class\n";
	}
};

class Derived: public Base {//(1)Inheritance from 					
							//class Base
	External_class external;//(2)Composition of 					
							//class External 
							//for greater operations.
public:
	void derived_function() {	
		cout
		<< "\t* operating at derived class\n";
		base_function();
		external.external_function();
	}
};

int main()
{
  Derived derived;
  cout
  << "\ncalling: \"derived.derived_function();\"\n";
  derived.derived_function();
  just_pause();
}
