// inheritance_in_generic.cpp

#include "my_essentials.hpp"

template<typename TB>
class base_template{
public:
	void say_hello(){
  cout	<< " Hello, I am a member of base_template!"
	<<"\n I am using the type of size "
	<<sizeof(TB)<<endl;
	}
};

template<typename TD>
class derived_template1: public base_template<TD>{
public:
	void say_hello_of_base(){
	/* say_hello();
	It is fine in Visual C++ 2010, but GCC 4.5.2 says:
	Error: there are no arguments to 'say_hello' 
	that depend on a template parameter, so a declaration 
	of 'say_hello' must be available */
	    this->say_hello();
	}
};

int main()
{
	derived_template1<char> der_temp;
	der_temp.say_hello_of_base();
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
