// container_adapters.cpp

#include "my_essentials.hpp"
#include <stack>
#include <queue>

void test_container_adapters() 
{
  stack<int> st;
  queue<int>qu;
  priority_queue<int>pq;

  cout << "\n push: 100, 10, 1000 \n";
  st.push(100); st.push(10); st.push(1000);
  qu.push(100); qu.push(10); qu.push(1000);
  pq.push(100); pq.push(10); pq.push(1000);

  cout << "\n top of the stack	= " << st.top();
  cout << "\n front of the queue 	= " << qu.front();
  cout << "\n top of the pri_qu	= " << pq.top();

  cout	<< "\n\n pop one element from each"
		<< "\n adapter, then,";
  st.pop(); qu.pop(); pq.pop();

  cout << "\n top of the stack 	= " << st.top();
  cout << "\n front of the queue  	= " << qu.front();
  cout << "\n top of the pri_qu 	= " << pq.top();

  cout	<< "\n\n pop one more element from each"
	<< "\n adapter, and then,";
  st.pop(); qu.pop(); pq.pop();

  cout << "\n top of the stack  	= " << st.top();
  cout << "\n front of the queue  	= " << qu.front();
  cout << "\n top of the pri_qu 	= " << pq.top() 
	<< endl;
}

int main()
{
	test_container_adapters();
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
