// user_defined_exception.cpp

#include "my_essentials.hpp"

struct name_at{
	string here;
	string there;
};

int main()
try{
	int a = 2, b=1;
	if(b == 0)throw b;
	cout << "\n (1) a/b = " << a/b<<endl;
	
	name_at name;
	name.there = "name_x";
	name.here = "name_y";

	if(name.here != name.there)	throw(name);
	cout << "\n (2)Good: name matches: "
		<< name.here << ", " << name.there << endl;
	just_pause();
	return 0;
}
catch(int& e){
	cout<<"\n (1) Error: denominator is "
	<<e<<endl;
	just_pause();
	return 1;
}
catch(name_at& e){
	cout<<"\n (2) Caution: name has changed from"
	<< ' ' << e.there << " to " << e.here <<"!\n";
	just_pause();
	return 2;
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
