// file.cpp

#include "my_essentials.hpp"
#include <iomanip>

/*
void sure_write(string& filename) // THIS FUNCTION 
// IS ADDED IN THE HEADER FILE MY_ESSENTIALS.H
{
	fstream fo(filename);
	bool flag1 = fo.is_open();
	fo.close();
	if(flag1)
	{
		cout << "The file : "<< filename 
		<< " already exists!\n"
		<<"Do you want to overwrite? (for yes"
		<<" enter y/for no enter n): ";
		char flag2;
		cin >> flag2;
		if(flag2 == 'n' || flag2 == 'N')
		{
			cout << "\n Ok, please enter "
				<<"another file name: ";
			cin >> filename;
			sure_write(filename);
		}
	}
}
*/

void write_txt(string& filename)
{		
	sure_write(filename);
	fstream fo(filename, ios_base::out);
	fo << "Hello World!";
	fo.close();
	cout << "\nThe file "<< filename 
		<< " is successfully written.\n";
}
	
int read_txt(string filename)
{
	cout << "\nNow reading the file "
			<< filename << ":\n";
	fstream fi(filename, ios_base::in); 
	if(!fi){
		cout 	<< "\n Error in opening the"
			<< " file: "<< filename << endl;
		return 1;
	}

	string str;
	cout << endl;
	while(getline(fi, str))
	{
		cout << str;
	}
	cout << endl;
	fi.close();
	return 0;
}

int main()
{
	string filename("my_data1.txt");
	write_txt(filename);
	read_txt(filename);
	just_pause();
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
