// additional_operations_of_vector.cpp

#include "my_essentials.hpp"
class my_vector_demo{
public:
	void operators_of_vector_template();
};

int main()
{
	my_vector_demo vdemo;
	vdemo.operators_of_vector_template();
	just_pause();
}

void my_vector_demo::operators_of_vector_template()
{
	cout << "\nList of special \"operators\" of std::vector<T>:\n";
	//let us generate a sample vector (1,2,3,4,5,6)
	vector<double>my_vec(8);
	generate(my_vec.begin(), my_vec.end(),
		[]()->double{static double d=1; return d++;} );
	cout_container("\n  Let us define a vector:\n\tmy_vec", my_vec);

	cout << "\n  Use of operators (1) operator[] and (2) at():"<<endl;
	cout << "\tmy_vec[2] = "<<my_vec[2]<<"; my_vec.at(2) = "<<my_vec.at(2);
	
	cout << "\n\n  Use of operators (3) reserve() \n\t"
			<<"- reserves required storage and allocates new space if required:";
	my_vec.reserve(10);
	cout << "\n\tmy_vec.reserve(10); my_vec.capacity()= "<<my_vec.capacity();
	cout<< "\n\twhere, operator (4) capacity() returns vector storage capacity."
			<< "\n\tThese operators do not affect the elements contained"
			<< " in the vector.\n\tThus unchanged ";
	cout_container("my_vec",my_vec);	
}

/***************************************

Copyright  2013 Coding4You
N. S. Pattabi Raman 

Permission to use this software 
for academic or commercial purpose
is hereby granted to the programmers
who have purchased the book,
Concise exposure to C++.

N. S. Pattabi Raman makes no 
representations about the suitability
of this software for any purpose. 
It is provided "as is" without express 
or implied warranty. 

***************************************/
